USES Errors,Recuadro,Crt,Dos;

CONST version='1.1';


VAR FONT:ARRAy[0..16*256-1] OF Byte;
    FontH:Byte;
    DoShadow:Boolean;
    X:Byte;
    Golded:Boolean;

CONST Normal:LIST=(0,0,0,0,0,0,0,0,13,27,0);
      FillChar:Char='';
      ShadowChar:Char='';
      SpaceChar:Char=' ';
      StdFile:String='LETROTAS.TXT';


      PROCEDURE PrepareGolded;
      VAR F:FILE;
      BEGIN
       GoldEd:=True;
       StdFile:='TMP.TMP';
       Assign(F,StdFile);
       Erase(F);
      END;

PROCEDURE LoadFont(S:String);
VAR F:File;
    Path:String;
BEGIN
 Path:=GetEnv('Path');
 S:=Fsearch(S,'.;'+Path);
 IF S='' THEN BEGIN
               TextATtr:=7;
                      Clrscr;
                      WriteLn('Error: Font no se encuentra.');
                      Halt
                     END;
 Assign(F,S);
 Reset(F,1);
 FontH:=(FileSize(F)-16) DIV 256;
 BlockRead(F,FONT,16);
 BlockRead(F,FONT,256*FontH);
 Close(F);
END;

PROCEDURE Help;
BEGIN
 textAttr:=7;
 Clrscr;
  WriteLn('LETROTAS ',version,' CopyRight 1997 NM Software');
  WriteLn;
 WriteLn('SINTAXIS: LETROTAS [/c<font>[.FNT]] [/s] [/f<fichero>]');
 WriteLn;
 WriteLn('Por defecto cargar el font NORMAL.FNT y usar el fichero LETROTAS.TXT');
 WriteLn;
 WriteLn('/s    -> Caracteres con sombra');
 WriteLn('/f    -> Indica a que fichero se aadir el texto.');
 WriteLn;
 Halt;
END;

VAR FS:String;
    T:text;
    R:textBox;
    texto:String;
    MyDir:String;


PROCEDURE DoubleWrite(A:Char);
BEGIN
 Write(T,A);
{ IF A=#10 THEN Write(T,#13);}

 IF A=#10 THEN
  BEGIN
   A:=#0;
   IF X<82 THEN BEGIN
                 Write(#10);
                 Write(#13);
                END;
    X:=0;
   END;
  IF X<81 THEN IF (A<>#0) THEN Write(A);
 INC(X);
END;

PROCEDURE CheckParams;
VAR I,J:Byte;
    S:String;
BEGIN
 IF ParamStr(1)='/h' THEN Help;
 FOR I:=1 TO ParamCount DO
  BEGIN
   S:=ParamStr(I);
   FOR J:=1 TO Byte(S[0]) DO S[J]:=UpCase(S[J]);
   IF (S='/S') THEN DoShadow:=True;
   IF Copy(S,1,2)='/C' THEN FS:=Copy(S,3,255);
   IF Copy(S,1,2)='/F' THEN StdFile:=Copy(S,3,255);;
  END;
END;


PROCEDURE Doit(S:String);
VAR C,I,J:Byte;
    X:Byte;
BEGIN

 FOR I:=0 TO FontH-1 DO
  BEGIN
   FOR C:=1 TO byte(S[0]) DO
    BEGIN
     FOR J:=0 TO 7 DO
       IF (FONT[byte(S[C])*FONTH+I] SHR (7-J)) MOD 2=1 THEN
         DoubleWrite (FillChar)
         else IF NOT DOShadow THEN DoubleWrite(SpaceChar)
                               ELSE
                                IF (FONT[byte(S[C])*FONTH+I] SHR (8-J)) MOD 2=1 THEN  BEGIN
                                                                                       DoubleWrite(ShadowChar);
                                                                                      END
                                                                                ELSE DoubleWrite(SpaceChar);
     IF DoShadow THEN DoubleWrite(SpaceChar);
    END;

   DoubleWrite(#13);
   DoubleWrite(#10);
  END;
END;



PROCEDURE CheckCFG;
VAR T:text;
    S:String;
BEGIN
 S:=FSearch('LETROTAS.CFG','.;'+GetEnv('PATH'));
 IF S='' THEN Exit;
 Assign(T,S);
 reset(T);
 IF IOresult<>0 THEN Exit;
 Read(T,SpaceChar);
 Read(T,ShadowChar);
 Read(T,FillChar);
 Close(T);
END;

PROCEDURE InsertFile;
VAR T1,T2,T3:Text;
    S,S2:String;
    F:FILE;
BEGIN
 Assign(T1,'GOLDED.MSG');
 Reset(T1);
 IF IOResult<>0 THEN BEGIN
                      WriteLn('GOLDED.MSG no se encuentra.');
                      Halt
                     END;
 Assign(T2,'TMP.TMP');
 Reset(T2);
 IF IOResult<>0 THEN Exit;
 Assign(T3,'TMP2.TMP');
 Rewrite(T3);
 WHILE NOT EOF(T1) DO
  BEGIN
   ReadLn(T1,S);
   IF (Copy(S,1,3)='---') OR (Copy(S,1,3)='...') OR (Copy(S,1,3)='-+-') OR (Copy(S,1,3)=' * ') THEN
      WHILE NOT EOF(T2) DO
            BEGIN
             ReadLn(T2,S2);
             WriteLn(T3,S2);
            END;
   WriteLn(T3,S);
  END;
 Close(T1);
 Close(T2);
 Close(T3);
 Erase(T1);
 Assign(F,'GOLDED.MSG');
 Erase(F);
 Assign(F,'TMP2.TMP');
 RENAME(F,'GOLDED.MSG');
 Assign(F,'TMP.TMP');
 Erase(F);
END;



BEGIN
 Golded:=False;
  TextAttr:=$1f;
  Clrscr;
  DoShadow:=False;
  CheckCfg;
  textAttr:=$4E;
  Write(' LETROTAS ',version,' CopyRight 1997 NM Software'); clreol;
  WriteLn;
  FS:='';
  CheckParams;
  IF FS='' THEN FS:='NORMAL.FNT';
  IF Pos('.',FS)=0 THEN FS:=FS+'.FNT';
  LoadFont(FS);
  REPEAT
   TextAttr:=$1f;
   Clrscr;
   textAttr:=$4E;
   Write(' LETROTAS ',version,' CopyRight 1997 NM Software'); clreol;
   WriteLn;
   IF StdFile='GOLDED.MSG' THEN PrepareGolded;
   Assign(T,StdFile);
   Append(T);
   IF IOResult<>0 THEN Rewrite(T);
   R.Init('TEXTO',9,34,7,45,9,$71,$70,True);
   R.EDit(Normal);
   texto:=R.Gettext;
   R.Release;
   Window(1,2,80,25);
   textAttr:=$07;
   Clrscr;
   Window(1,1,80,25);
   GotoXY(1,3);
   X:=1;
   Doit(Texto);
   GotoXY(1,25);Write(' Pulse una tecla para continuar...');
   IF texto <>'' THEN Readkey;
   Close(T);
  UNTIL texto='';
  IF GoldEd THEN InsertFile;
  GotoXY(1,25);Clreol;
  GotoXY(1,24);
 END.

